 

                                                 --  xQd's sr3 city lua file --


-- Gameplay Choice IDs -------------------------------
-- these should match values from level_scripts.cpp
MISSION_06_CHOICE = 0
MISSION_22_CHOICE = 1
MISSION_21_CHOICE = 2

M06_CHOICE_BLOWN_TOWER = true;
M06_CHOICE_BRANDED_TOWER = false;
M22_CHOICE_KILLBANE_KILL = true;
M22_CHOICE_KILLBANE_ESCAPE = false;	
M21_CHOICE_KILLBANE_UNMASKED = true;
M21_CHOICE_KILLBANE_NOT_UNMASKED = false;

------------------------------------------------------
 TERRITORY_FIGHTS_MAIN_HANDLE = INVALID_THREAD_HANDLE
 TERRITORY_FIGHT_HANDLE = INVALID_THREAD_HANDLE
 
function sr3_city_init()
end


function sr3_city_main()
        TERRITORY_FIGHTS_MAIN_HANDLE = thread_new("GenerateRandomAttacks")
end
-- ***********************************************************************************************************************************
function GenerateRandomAttacks()
	local intrvl 
	local hoodGang
	local tfThread = true
	while tfThread == true do			
		if( mission_is_complete("m22")) then
			intrvl = rand_int(600,750)
		elseif( mission_is_complete("m21")) then 
			intrvl = rand_int(600,750)
		elseif( mission_is_complete("m20")) then
			intrvl = rand_int(600,800)
		elseif( mission_is_complete("m16")) then
			intrvl = rand_int(600,850)
		elseif( mission_is_complete("m15")) then
			intrvl = rand_int(600,900)
		elseif( mission_is_complete("m14")) then
			intrvl = rand_int(650,950)     
		elseif( mission_is_complete("m09")) then
			intrvl = rand_int(650,1000)
		elseif( mission_is_complete("m08")) then
			intrvl = rand_int(650,1050)
		elseif( mission_is_complete("m07")) then
			intrvl = rand_int(700,1100)
		elseif( mission_is_complete("m06")) then
			intrvl = rand_int(750,1150) 
		elseif( mission_is_complete("m05")) then
			intrvl = rand_int(800,1200)
		elseif( mission_is_complete("m04")) then
			intrvl = rand_int(850,1250)
		elseif( mission_is_complete("m03")) then 
			intrvl = rand_int(900,1300)
		end
		delay(intrvl) -- random interval between attacks
		if( mission_is_active() == false ) then	
			if (notoriety_gang_inexistent() == true and notoriety_get("Police") == 0) then
				notoriety_allow_indoor_gang_spawning(false)
				hoodGang = GetGangByCurrentHood()
				hud_set_fake_notoriety( hoodGang, true, 0)
				notoriety_set(hoodGang, 2)
				notoriety_set_max(hoodGang, 3)
				notoriety_set_can_decay(true)				

				delay(7) --wait for notoriety to set
				if (notoriety_get("deckers") == 1 or notoriety_get("luchadores") == 1 or notoriety_get("Morningstar") == 1) then
					notoriety_reset(hoodGang)
				elseif (notoriety_get("deckers") == 2 or notoriety_get("luchadores") == 2 or notoriety_get("Morningstar") == 2)  then
					TERRITORY_FIGHT_HANDLE = thread_new("beginWarfare")
					repeat
						delay(0.5)
					until (notoriety_gang_inexistent() == true and notoriety_get("Police") == 0)
						
					EndWarfare(hoodGang)
				end				
			end				
		end
		thread_yield()
	end
end

function beginWarfare()
	delay(rand_int(150,180)) --countdown
	local gangWarfare = true
	while gangWarfare == true do	
		if ( character_is_combat_ready("#PLAYER#") == true and character_is_in_vehicle("#PLAYER#") == false) then
			if (notoriety_get("Police") <= 2) then		
				if (notoriety_get("deckers") >= 2 or notoriety_get("luchadores") >= 2 or notoriety_get("Morningstar") >= 2) then
					hud_set_fake_notoriety( "Police", true, 0)
					notoriety_set("Police", 2)
					notoriety_set_max("Police", 3)
					notoriety_set_can_decay(true)
				elseif (notoriety_get("deckers") == 1 or notoriety_get("luchadores") == 1 or notoriety_get("Morningstar") == 1) then
					notoriety_reset("Police")
				end			
			end
			delay(60) --interval between police appearances			
			if (notoriety_get("deckers") == 3 or notoriety_get("Morningstar") == 3 or notoriety_get("luchadores") == 3) then
				local kingsOfTheHood = get_hood_owner(get_current_hood_by_position("#PLAYER#"))				
				if kingsOfTheHood == "Playas" then
					hud_set_fake_notoriety( "Morningstar", true, 0)
					hud_set_fake_notoriety( "luchadores", true, 0)
					hud_set_fake_notoriety( "deckers", true, 0)
					notoriety_set_max("Morningstar", 1)
					notoriety_set_max("luchadores", 1)
					notoriety_set_max("deckers", 1)
					
					hud_set_fake_notoriety( "Police", true, 0)
					notoriety_set_max("Police", 4)					
					notoriety_set("Police", 4)
					notoriety_set_can_decay(true)
				else
					hud_set_fake_notoriety(kingsOfTheHood, true, 0)
					notoriety_set(kingsOfTheHood, 4)
					notoriety_set_max(kingsOfTheHood, 4)
					notoriety_set_can_decay(true)
				end
			end	
		end			
		delay(0.5)		
	end
end

function EndWarfare(hoodGang)
	notoriety_reset(hoodGang)
	notoriety_set_max(hoodGang,5)
	notoriety_reset("Police")
	notoriety_set_max("Police",5)	
	thread_kill(TERRITORY_FIGHT_HANDLE)
end

function notoriety_gang_inexistent()
	if ( notoriety_get("deckers") == 0 and notoriety_get("luchadores") == 0 and notoriety_get("Morningstar") == 0) then
		return true
	else
		return false
	end
end

function GetGangByCurrentHood()
	local current_neighborhood = get_current_hood_by_position("#PLAYER#")
	
	if current_neighborhood == "HOOD_NEW_BARANEC" then
		return "luchadores"
	elseif current_neighborhood == "HOOD_DT_02" then
		return "Morningstar"
	elseif current_neighborhood == "HOOD_NE_04" then
		return "Morningstar"
	elseif current_neighborhood == "HOOD_DT_01" then
		return "Morningstar"
	elseif current_neighborhood == "HOOD_BRIDGEPORT" then
		return "luchadores"
	elseif current_neighborhood == "HOOD_NW_04" then
		return "deckers"
	elseif current_neighborhood == "HOOD_ZOMBIE" then
		return "luchadores"
	elseif current_neighborhood == "HOOD_NW_02" then
		return "deckers"
	elseif current_neighborhood == "HOOD_NE_02" then
		return "Morningstar"
	elseif current_neighborhood == "HOOD_NW_01" then
		return "deckers"
	elseif current_neighborhood == "HOOD_NW_03" then
		return "deckers"
	elseif current_neighborhood == "HOOD_SIERRA_POINT" then
		return "Morningstar"
	elseif current_neighborhood == "HOOD_POINT_PRYOR" then
		return "luchadores"
	elseif current_neighborhood == "HOOD_NE_03" then
		return "Morningstar"
	elseif current_neighborhood == "HOOD_DT_03" then
		return "Morningstar"
	elseif current_neighborhood == "HOOD_DOWNERS_GROVE" then
		return "luchadores"
	elseif current_neighborhood == "HOOD_NE_01" then
		return "Morningstar"
	elseif current_neighborhood == "HOOD_YEARWOOD" then
		return "luchadores"
	else
		return "Police"
	end
end

-- ***********************************************************************************************************************************


                                --- Vanilla functions below (things we shouldnt be playin with) ---





-- ALL FOLLOWING COOP SKIP FUNCTIONS CALLED FROM CODE (+++MUST RETURN IMMEDIATLY+++)

-- Teleport players to a mission start node
--
-- mission_name:	(string) name of the mission start node (should be same as mission name)
-- skip_teleport:	(boolean) true to basically skip this whole function, nil or not true will run it
--
function sr3_teleport_mission_start(mission_name, skip_teleport)
	if skip_teleport == nil or skip_teleport ~= true then
		-- send them to the mission start
		local vehicle_exit = true
		local offset_x = 0.5
		teleport_to_object(LOCAL_PLAYER, mission_name, vehicle_exit, nil, offset_x)
		-- remote player not on top of player
		offset_x = -0.5
		teleport_to_object(REMOTE_PLAYER, mission_name, vehicle_exit, nil, offset_x)
	end
end

function m03_coop_skip( )
	crib_purchasing_unlock( )
end

function m06_coop_skip(skip_teleport)
	sr3_teleport_mission_start("m06", skip_teleport)
	-- Update the world state based on the choice that they made during the mission
	if game_choice_get_state( MISSION_06_CHOICE ) == M06_CHOICE_BRANDED_TOWER then
		city_zone_swap("tower_saints")
	else
		city_zone_swap("tower_dmg")
	end
	-- kill the building interior either way
	city_zone_swap("m6")

	-- Set Hood ('Henry Steel Mills') to Spawn THE BALL from now on as ambient
	spawn_override_change_hood_alternate_spawning("HOOD_DT_01", true)

	if not mission_is_complete( "m07" ) then
		-- make sure we unlocked it
		mission_unlock( "m07" )
		mission_set_next_mission( "m07" )
	end
end

function m10_coop_skip(skip_teleport)
	sr3_teleport_mission_start("m10", skip_teleport)
	set_stag_active(true)
	spawn_override_change_hood_alternate_spawning("HOOD_DT_02", true)
	
	city_zone_swap("thermext1") -- Thermopolye moves to south of DT
	city_zone_swap("therm2") -- This swap just the interior trigger and volume for thermext1.  Those two should be consolidated.
	city_zone_swap("stag") -- STAG shows up in DT
	traffic_disable_drawbridge_area(34, true) -- Disables splines on road through Sunset Park that STAG cordons off
end

function m13_coop_skip(skip_teleport)
	sr3_teleport_mission_start("m13", skip_teleport)
	city_zone_swap("hq_dmg") -- HQ is damaged during this mission, swap it in
end

function m14_coop_skip( )
	-- Set Saints to be 'Hated' following this mission
	set_saints_hated(true)
end

function m17_coop_skip(skip_teleport)
	sr3_teleport_mission_start("m17", skip_teleport)
	-- Set STAG Lockdown spawning for downtown hoods to True (Hood DT_02 still missing change, waiting on Chris N. solution to having two alternate spawn groups)
	spawn_override_change_hood_alternate_spawning("HOOD_DT_02", true)
	spawn_override_change_hood_alternate_spawning("HOOD_DT_03", true)
	
	-- Set STAG Lockdown area as immediate notoriety area
	set_stag_notoriety_area_active(true)
	
	-- Post mission swaps, Thermopolye destroyed and STAG take over downtown
	city_zone_swap("thermext1", false)
	city_zone_swap("therm2", false) -- This swap just the interior trigger and volume for thermext1.  Those two should be consolidated.
	city_zone_swap("therm3_dst")
	city_zone_swap("lockdown")
	
	-- Disable Traffic Splines Over Drawbridges
	traffic_disable_drawbridge_area(1, true)
	traffic_disable_drawbridge_area(2, true)
	traffic_disable_drawbridge_area(7, true)
	traffic_disable_drawbridge_area(8, true)
	traffic_disable_drawbridge_area(9, true)
	traffic_disable_drawbridge_area(10, true)
	traffic_disable_drawbridge_area(11, true)
	traffic_disable_drawbridge_area(12, true)
	traffic_disable_drawbridge_area(13, true)
	traffic_disable_drawbridge_area(14, true)
	traffic_disable_drawbridge_area(15, true)
	traffic_disable_drawbridge_area(16, true)
	traffic_disable_drawbridge_area(17, true)
	traffic_disable_drawbridge_area(18, true)
	traffic_disable_drawbridge_area(19, true)
	traffic_disable_drawbridge_area(20, true)
	traffic_disable_drawbridge_area(21, true)
	traffic_disable_drawbridge_area(22, true)
	traffic_disable_drawbridge_area(23, true)
	traffic_disable_drawbridge_area(24, true)
	traffic_disable_drawbridge_area(25, true)
	traffic_disable_drawbridge_area(27, true)
	traffic_disable_drawbridge_area(28, true)
	traffic_disable_drawbridge_area(29, true)
	traffic_disable_drawbridge_area(30, true)
	traffic_disable_drawbridge_area(31, true)
	traffic_disable_drawbridge_area(32, true)
	traffic_disable_drawbridge_area(33, true)
end

function m18_coop_skip(skip_teleport)
	sr3_teleport_mission_start("m18", skip_teleport)
	-- Set Hood ('Arapice Island') to Spawn Zombies from now on as ambient
	spawn_override_change_hood_alternate_spawning("HOOD_ZOMBIE", true)
	
	-- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled'
	traffic_disable_drawbridge_area(3, true)
	traffic_disable_drawbridge_area(4, true)
	traffic_disable_drawbridge_area(5, true)
	traffic_disable_drawbridge_area(6, true)
	traffic_disable_drawbridge_area(26, true)
	
	-- Swap the Zombie zone
	city_zone_swap("chemcrash")
	city_zone_swap("zombies")
end

function m22_coop_skip(skip_teleport)
	sr3_teleport_mission_start("m22", skip_teleport)
	if game_choice_get_state( MISSION_22_CHOICE ) == M22_CHOICE_KILLBANE_KILL then
		mission_unlock( "m23" )
		city_zone_swap("rubble") -- Player went for Killbane, statue got blowed up
	else
		mission_unlock( "m24" )
	end
end

function m23_m24_coop_skip(skip_teleport)
	sr3_teleport_mission_start("m23", skip_teleport)
	
	-- Set STAG Inactive
	set_stag_active(false)
	
	-- Remove Lockdown Spawning from Downtown Hoods
	spawn_override_change_hood_alternate_spawning("HOOD_DT_02", false)
	spawn_override_change_hood_alternate_spawning("HOOD_DT_03", false)
	
	-- Set Traffic to Be Enabled Across Lockdown Drawbridges Again
	traffic_disable_drawbridge_area(7, false)
	traffic_disable_drawbridge_area(8, false)
	traffic_disable_drawbridge_area(9, false)
	traffic_disable_drawbridge_area(10, false)
	traffic_disable_drawbridge_area(11, false)
	traffic_disable_drawbridge_area(12, false)
	traffic_disable_drawbridge_area(13, false)
	traffic_disable_drawbridge_area(14, false)
	traffic_disable_drawbridge_area(15, false)
	traffic_disable_drawbridge_area(16, false)
	traffic_disable_drawbridge_area(17, false)
	traffic_disable_drawbridge_area(18, false)
	traffic_disable_drawbridge_area(19, false)
	traffic_disable_drawbridge_area(20, false)
	traffic_disable_drawbridge_area(21, false)
	traffic_disable_drawbridge_area(22, false)
	traffic_disable_drawbridge_area(23, false)
	traffic_disable_drawbridge_area(24, false)
	traffic_disable_drawbridge_area(25, false)
	traffic_disable_drawbridge_area(27, false)
	traffic_disable_drawbridge_area(28, false)
	traffic_disable_drawbridge_area(29, false)
	traffic_disable_drawbridge_area(30, false)
	traffic_disable_drawbridge_area(31, false)
	traffic_disable_drawbridge_area(32, false)
	traffic_disable_drawbridge_area(33, false)
	traffic_disable_drawbridge_area(34, false)
	
	-- Disable Downtown Notoriety Areas
	set_stag_notoriety_area_active(false)
	
	-- Set Saints to be beloved again
	set_saints_hated(false)
	
	-- Perform zone swaps
	city_zone_swap("hq_dmg", DISABLE) -- restore saints HQ
	
	-- Maybe allow you to play through again
	mission_maybe_uncomplete_m22()
end

function sh02_coop_skip(skip_teleport)
	sr3_teleport_mission_start("sh02", skip_teleport)
	crib_unlock_strongold("Crib_BDSM")
end

function sh03_coop_skip(skip_teleport)
	sr3_teleport_mission_start("sh03", skip_teleport)
	crib_unlock_strongold("Crib_Nuke")
end

function sh04_coop_skip(skip_teleport)
	sr3_teleport_mission_start("sh04", skip_teleport)
	crib_unlock_strongold("Crib_3Count")
end
